CFPRIME AEXC9                                                           AEXC9       1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
      SUBROUTINE AEXC9(ISTATE)                                          AEXC9       3
CD                                                                      AEXC9       4
CD    TO FORMULATE THE JACOBIAN MATRICES OF TYPE 9 EXCITER              AEXC9       5
CD    (IEEE TYPE DC3).                                                  AEXC9       6
CD                                                                      AEXC9       7
      INCLUDE 'PARX.INS'                                                AEXC9       8
      INCLUDE 'CNB8.INS'                                                AEXC9       9
      INCLUDE 'CNEXC.INS'                                               AEXC9      10
      INCLUDE 'CNPARX.INS'                                              AEXC9      11
      INCLUDE 'CNMDAT.INS'                                              AEXC9      12
      INCLUDE 'CNXSTA.INS'                                              AEXC9      13
      INCLUDE 'CNMSTA.INS'                                              AEXC9      14
C                                                                       AEXC9      15
      INCLUDE 'CNABAK.INS'                                              AEXC9      16
C                                                                       AEXC9      17
C     SUBSCRIPTS                                                        AEXC9      18
C                                                                       AEXC9      19
      ISUB1=ISTATE+1                                                    AEXC9      20
      ISUB2=ISTATE+2                                                    AEXC9      21
      ISUB3=ISTATE+3                                                    AEXC9      22
C                                                                       AEXC9      23
C     KV-TRH AND TE BLOCKS                                              AEXC9      24
C                                                                       AEXC9      25
      TEI=1.0/DDAT(JE+5)                                                AEXC9      26
      IF (IDDAT(JE+21).EQ.1) THEN                                       AEXC9      27
         DELTA1=(DDAT(JE+14)-DDAT(JE+15))/(DDAT(JE+10)*DDAT(JE+11))     AEXC9      28
         DELTA2=TEI                                                     AEXC9      29
      ELSE                                                              AEXC9      30
         DELTA1=0.0                                                     AEXC9      31
         DELTA2=0.0                                                     AEXC9      32
      END IF                                                            AEXC9      33
C                                                                       AEXC9      34
      VE=XSTATE(JSTATE+3)                                               AEXC9      35
      BETA=DDAT(JE+4)+DDAT(JE+6)*DDAT(JE+7)                             AEXC9      36
     *     *EXP(DDAT(JE+7)*VE)                                          AEXC9      37
C                                                                       AEXC9      38
      A(ISUB3,ISUB2)=DELTA2                                             AEXC9      39
      A(ISUB3,ISUB3)=-BETA*TEI                                          AEXC9      40
C                                                                       AEXC9      41
      IF (INPUTR.EQ.0.AND.IDDAT(JE+21).EQ.1) THEN                       AEXC9      42
         CALL BCBTEM(ISUB2,DELTA1)                                      AEXC9      43
      ELSE                                                              AEXC9      44
         A(ISUB2,ISUB1)=-DELTA1                                         AEXC9      45
      END IF                                                            AEXC9      46
C                                                                       AEXC9      47
      IUST(1)=ISUB2                                                     AEXC9      48
      GUST(1)=DELTA1                                                    AEXC9      49
C                                                                       AEXC9      50
C     INTERCONNECTION WITH GENERATOR                                    AEXC9      51
C                                                                       AEXC9      52
      A(3,ISUB3)=CFEXC                                                  AEXC9      53
C                                                                       AEXC9      54
      ISTATE=ISUB3                                                      AEXC9      55
C                                                                       AEXC9      56
      RETURN                                                            AEXC9      57
      END                                                               AEXC9      58
